--[[
--  thek_Unitframes: classthings
--  version: 1.0.cataclysm
--  author:  thek
--
--  some class specific changes
--]]


local c = thek_Unitframes_Config;

-- go --------------------------------------------------------------------
local function OnDragStart(f)
	if not InCombatLockdown() and IsAltKeyDown() then
		_G[f]:StartMoving()
	end
end

local function OnDragStop(f)
	_G[f]:StopMovingOrSizing()
    THEK_UNITFRAMES[f] = {unpack({_G[f]:GetPoint()})};
end

-- shaman
if select(2, UnitClass("player")) == "SHAMAN" then
    TotemFrame:SetMovable(true);
    TotemFrame:SetUserPlaced(true);
    TotemFrame:SetClampedToScreen(true);
    TotemFrame:SetWidth((c["classThings"].iconSize * 4) + (c["classThings"].iconSpacing * 4));
    for i = 1, 4 do
        select(2, _G["TotemFrameTotem"..i]:GetChildren()):Hide();
        select(2, _G["TotemFrameTotem"..i]:GetChildren()).Show = function() end;
        _G["TotemFrameTotem"..i.."IconTexture"]:SetTexCoord(.1, .9, .1, .9);
        _G["TotemFrameTotem"..i.."Background"]:Hide();
        _G["TotemFrameTotem"..i.."Background"].Show = function () end;
        _G["TotemFrameTotem"..i]:RegisterForDrag("LeftButton");
        _G["TotemFrameTotem"..i]:SetScript("OnDragStart", function() OnDragStart("TotemFrame") end);
        _G["TotemFrameTotem"..i]:SetScript("OnDragStop", function() OnDragStop("TotemFrame") end);
        _G["TotemFrameTotem"..i]:SetWidth(c["classThings"].iconSize);
        _G["TotemFrameTotem"..i]:SetHeight(c["classThings"].iconSize);
        _G["TotemFrameTotem"..i.."Icon"]:SetWidth(c["classThings"].iconSize);
        _G["TotemFrameTotem"..i.."Icon"]:SetHeight(c["classThings"].iconSize);
        _G["TotemFrameTotem"..i.."Duration"]:ClearAllPoints();
        _G["TotemFrameTotem"..i.."Duration"]:SetPoint("TOP", _G["TotemFrameTotem"..i.."Icon"], "BOTTOM", 0, -c["classThings"].iconSpacing / 4);
        _G["TotemFrameTotem"..i.."Duration"]:SetFont(c["font"].face, c["font"].size, c["font"].options);
        _G["TotemFrameTotem"..i]:ClearAllPoints();
        if i == 1 then
            _G["TotemFrameTotem"..i]:SetPoint("LEFT", TotemFrame, "LEFT", 2, 0);
        else
            _G["TotemFrameTotem"..i]:SetPoint("LEFT", _G["TotemFrameTotem"..(i-1)], "RIGHT", c["classThings"].iconSpacing, 0);
        end
        _G["TotemFrameTotem"..i].bg = CreateFrame("Frame", nil, _G["TotemFrameTotem"..i])
        _G["TotemFrameTotem"..i].bg:SetFrameLevel(_G["TotemFrameTotem"..i.."Icon"]:GetFrameLevel() + 1);
        _G["TotemFrameTotem"..i].bg:SetWidth(c["classThings"].iconSize + c["classThings"].iconSpacing / 2)
        _G["TotemFrameTotem"..i].bg:SetHeight(c["classThings"].iconSize + c["classThings"].iconSpacing / 2)
        _G["TotemFrameTotem"..i].bg:SetPoint("CENTER", _G["TotemFrameTotem"..i], "CENTER")
        _G["TotemFrameTotem"..i].bgt = _G["TotemFrameTotem"..i].bg:CreateTexture(nil, "ARTWORK");
        _G["TotemFrameTotem"..i].bgt:SetAllPoints(_G["TotemFrameTotem"..i].bg);
		_G["TotemFrameTotem"..i].bgt:SetTexture(c["classThings"].borderTexture);
		_G["TotemFrameTotem"..i].bgt:SetTexCoord(1 / 128, 35 / 128, 207 / 256, 240 / 256);
        _G["TotemFrameTotem"..i].bgt:SetVertexColor(.4, .4, .4, .95);
    end;  
    
-- deathknight    
elseif select(2, UnitClass("player")) == "DEATHKNIGHT" then
    RuneFrame:SetMovable(true);
    RuneFrame:SetUserPlaced(true);
    RuneFrame:SetClampedToScreen(true);
    RuneFrame:SetWidth((c["classThings"].iconSize * 6) + (c["classThings"].iconSpacing * 6));
    for i = 1, 6 do        
        select(1, _G["RuneButtonIndividual"..i.."Border"]:GetRegions()):SetTexture("");
        _G["RuneButtonIndividual"..i.."Rune"]:SetTexCoord(.2, .8, .2, .8);
        _G["RuneButtonIndividual"..i]:RegisterForDrag("LeftButton");
        _G["RuneButtonIndividual"..i]:SetScript("OnDragStart", function() RuneFrame:SetParent(UIParent); OnDragStart("RuneFrame") end);
        _G["RuneButtonIndividual"..i]:SetScript("OnDragStop", function() OnDragStop("RuneFrame") end);
        _G["RuneButtonIndividual"..i]:SetWidth(c["classThings"].iconSize);
        _G["RuneButtonIndividual"..i]:SetHeight(c["classThings"].iconSize);
        _G["RuneButtonIndividual"..i.."Cooldown"]:SetWidth(c["classThings"].iconSize);
        _G["RuneButtonIndividual"..i.."Cooldown"]:SetHeight(c["classThings"].iconSize);
        _G["RuneButtonIndividual"..i.."Rune"]:SetWidth(c["classThings"].iconSize);
        _G["RuneButtonIndividual"..i.."Rune"]:SetHeight(c["classThings"].iconSize);
        _G["RuneButtonIndividual"..i]:ClearAllPoints();
        if i == 1 then
            _G["RuneButtonIndividual"..i]:SetPoint("LEFT", RuneFrame, "LEFT", 2, 0);
        else
            _G["RuneButtonIndividual"..i]:SetPoint("LEFT", _G["RuneButtonIndividual"..(i-1)], "RIGHT", c["classThings"].iconSpacing, 0);
        end
        _G["RuneButtonIndividual"..i].bg = CreateFrame("Frame", nil, _G["RuneButtonIndividual"..i])
        _G["RuneButtonIndividual"..i].bg:SetFrameLevel(_G["RuneButtonIndividual"..i]:GetFrameLevel() + 1);
        _G["RuneButtonIndividual"..i].bg:SetWidth(c["classThings"].iconSize + c["classThings"].iconSpacing / 2)
        _G["RuneButtonIndividual"..i].bg:SetHeight(c["classThings"].iconSize + c["classThings"].iconSpacing / 2)
        _G["RuneButtonIndividual"..i].bg:SetPoint("CENTER", _G["RuneButtonIndividual"..i], "CENTER")
        _G["RuneButtonIndividual"..i].bgt = _G["RuneButtonIndividual"..i].bg:CreateTexture(nil, "ARTWORK");
        _G["RuneButtonIndividual"..i].bgt:SetAllPoints(_G["RuneButtonIndividual"..i].bg);
		_G["RuneButtonIndividual"..i].bgt:SetTexture(c["classThings"].borderTexture);
		_G["RuneButtonIndividual"..i].bgt:SetTexCoord(1 / 128, 35 / 128, 207 / 256, 240 / 256);
        _G["RuneButtonIndividual"..i].bgt:SetVertexColor(.4, .4, .4, .95);        
    end;
    
-- rogue    
elseif select(2, UnitClass("player")) == "ROGUE" then
    local a = CreateFrame("Frame", "thek_Unitframes_Rogue_Combopoints", UIParent);
    a:SetPoint("CENTER", UIParent, "CENTER");
    a:Show();
    a:SetMovable(true);
    a:SetClampedToScreen(true);
    a:SetWidth((c["classThings"].iconSize * 5) + (c["classThings"].iconSpacing * 5));
    a:SetHeight(c["classThings"].iconSize + (c["classThings"].iconSpacing / 2));
    for i = 1, MAX_COMBO_POINTS do
        a[i] = CreateFrame("Statusbar", nil, a);
        a[i]:SetWidth(c["classThings"].iconSize);
        a[i]:SetHeight(c["classThings"].iconSize);
        a[i]:SetMinMaxValues(0, 1);
        a[i]:SetValue(0);
        a[i]:SetStatusBarTexture(c["classThings"].comboBarTexture);
        a[i]:SetStatusBarColor(unpack(c["classThings"].comboBarColor));
        if i == 1 then
            a[i]:SetPoint("LEFT", a, "LEFT", 2, 0);
        else
            a[i]:SetPoint("LEFT", a[(i-1)], "RIGHT", c["classThings"].iconSpacing, 0);
        end
        a[i].bg = CreateFrame("Frame", nil, a[i])
        a[i].bg:SetWidth(c["classThings"].iconSize + c["classThings"].iconSpacing / 2)
        a[i].bg:SetHeight(c["classThings"].iconSize + c["classThings"].iconSpacing / 2)
        a[i].bg:SetPoint("CENTER", a[i], "CENTER")
        a[i].bgt = a[i].bg:CreateTexture(nil, "ARTWORK");
        a[i].bgt:SetAllPoints(a[i].bg);
		a[i].bgt:SetTexture(c["classThings"].borderTexture);
		a[i].bgt:SetTexCoord(1 / 128, 35 / 128, 207 / 256, 240 / 256);
        a[i].bgt:SetVertexColor(.4, .4, .4, .95);
        a[i]:EnableMouse(true);
        a[i]:RegisterForDrag("LeftButton");
        a[i]:SetScript("OnDragStart", function() OnDragStart("thek_Unitframes_Rogue_Combopoints") end);
        a[i]:SetScript("OnDragStop", function() OnDragStop("thek_Unitframes_Rogue_Combopoints") end);        
    end;
    local function UpdateComboPoints()
        local cp = GetComboPoints(PlayerFrame.unit, "target");
        if cp > 0 then
            for i = 1, MAX_COMBO_POINTS do 
                if i <= cp then a[i]:SetValue(1) else a[i]:SetValue(0) end;
            end;
        else
            for i = 1, MAX_COMBO_POINTS do a[i]:SetValue(0) end;
        end;
    end;    
    a:RegisterEvent("PLAYER_TARGET_CHANGED");
    a:RegisterEvent("UNIT_COMBO_POINTS");
    a:SetScript("OnEvent", function(self, event, unit)
        if event == "PLAYER_TARGET_CHANGED" then 
            UpdateComboPoints();
        elseif event == "UNIT_COMBO_POINTS" then
            if unit == PlayerFrame.unit then UpdateComboPoints() end;
        end;
    end)
end;