--[[
--  thek_Unitframes: config
--  version: 1.0.cataclysm
--  author:  thek
--
--  configuration
--]]

thek_Unitframes_Config = {};
local c = thek_Unitframes_Config;

-- general configuration
c.showClassIcons    = true;

-- healthbartext configuration
c["player"] = {
    percent         = {true, "LEFT", "LEFT", 230, 3},
    current         = {false, "LEFT", "LEFT", 120, 3}
};
c["target"] = {
    percent         = {true, "RIGHT", "LEFT", 3, 3},
    current         = {true, "RIGHT", "LEFT", 120, 3}
};
c["focus"] = {
    percent         = {true, "RIGHT", "LEFT", 3, 3},
    current         = {true, "RIGHT", "LEFT", 120, 3}
};

-- targetbuff/-debuff settings
c["targetaura"]     = {
    largeSize       = 25,
    smallSize       = 19
};

-- totem-/rune-/comboframe configuration
c["classThings"] = {
    iconSize        = 28,
    iconSpacing     = 8,
    borderTexture   = "Interface\\Buttons\\UI-TotemBar",
    comboBarTexture = "Interface\\TargetingFrame\\UI-StatusBar",
    comboBarColor   = {.1, .9, .1},
};

-- font settings
c["font"] = {
    face            = "Fonts\\FRIZQT__.TTF",
    size            = 12,
    options         = "THINOUTLINE"
};